C    INCLUDE FILE FOR COMMON BLOCK /RESULT/ and /ENERGIES/:
C    Assuming file including this one uses: implicit double precision(a-h,o-z)

      COMMON /RESULT/ FHEAT,  FIONZN, FTOTAL, FEELEC,    FECORE, FDIPOL,
     &                FPOLAR, FATOMZ, 
     &                FMDIP,  FHALFD, FFULLD,                           LF0112
     &                FDISP,                                            LF0312
     &                FHEATS, FDIST(190),FGRADT,
     &                FGRPER, FNATMS, FPTE,   FBARHT,    FEREL(20),
     &                ATMCHG(40), NMBRAT, GUTRUN
      LOGICAL         GUTRUN

      COMMON /ENERGIES/ TOTALEN(4000), CALCDONE(4000)
      LOGICAL         CALCDONE

C
C    THE SUFFIXES ARE AS FOLLOWS:
C       IONZN  = VERTICAL IONIZATION POTENTIAL (EV)
C       DIPOL  = TOTAL DIPOLE MOMENT USING USER'S HYBRID FACTOR FOR HYBRID CONTRIBUTION (DEBYE)
C       POLAR  = POLARIZABILITY (CUBIC ANGSTROMS)
C       ATOMZ  = ATOMIZATION ENERGY (ZPE-EXCLUSIVE, KCAL/MOL)
C       MDIP   = DIPOLE USING ONLY MULLIKEN CHARGE CONTRIBUTION (DEBYE)
C       HALFD  = DIPOLE USING MULLIKEN AND 50% HYBRID CONTRIBUTION (DEBYE)
C       FULLD  = DIPOLE USING MULLIKEN AND 100% HYBRID CONTRIBUTION (DEBYE)
C       BONDL  = BOND LENGTH (ANGSTROMS)
C       BONDA  = BOND ANGLE (DEGREES)
C       GRADT  = GRADIENT NORM (WITH RESPECT TO ALL 3N CARTESIAN D.F.)
C       PTE    = PROTON TRANSFER ENERGY (KCAL/MOL)
C       EREL   = RELATIVE ENERGY OF DISTORTED STRUCTURES (KCAL/MOL)
C       BARHT  = BARRIER HEIGHT (USUALLY OF INTRAMOLECULAR TORSIONS,
C                E.G. FROM ECLIPSED TO ANTI CONFORMATIONS) (KCAL/MOL)
C       GRPER  = GRADIENT NORM PER CARTESIAN D.F.  (=(GRADT)/(3*NUMAT))
C                (KCAL/MOL)
C       AEPB   = ATOMIZATION PER BOND (A.E. DIVIDED BY # OF BONDS) (KCAL/MOL)
C       ATMCHG = ATOMIC CHARGE FOR INDIVIDUAL ATOMS (A.U.) (WORKS FOR BOTH
C                MULLIKEN (DEFAULT) AND CM2 CHARGES ("CM2" KEYWORD))
C       NMBRAT = NUMBER OF ATOMS IN SYSTEM
C       DISP   = DISPERSION ENERGY CALCULATED FROM THE "-D" METHODS (KCAL/MOL
C
C    GUTRUN IS A BOOLEAN INDICATING WHETHER THE MOPAC CALCULATION WAS
C    SUCCESSFUL.  IF NOT, THEN THERE ARE NO RESULTS RETURNED THAT CAN BE
C    USED.
C
C
